﻿#include "define.h"

#if atomic

#if multisample
	layout(binding = 0, r32ui) coherent uniform uimage2DMS	 image_counter;

	void addPixelFragCounter(ivec2 coords, uint val)		{imageAtomicAdd(image_counter, coords, gl_SampleID, val);}
#else
	layout(binding = 0, r32ui) coherent uniform uimage2DRect image_counter;

	void addPixelFragCounter(ivec2 coords, uint val)		{imageAtomicAdd(image_counter, coords, val);}
#endif 

void main(void)
{
	addPixelFragCounter(ivec2(gl_FragCoord.xy), 1U);
}

#else

layout(location = 0, index = 0) out vec4 out_frag_counter;

void main(void)
{
	out_frag_counter.r = 1.0f;
}

#endif